"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cors = void 0;
var tslib_1 = require("tslib");
var CorsMiddlewareOptions_1 = require("./interfaces/CorsMiddlewareOptions");
var handlePreflightRequest_1 = require("./handlePreflightRequest");
var handleNonPreflightRequest_1 = require("./handleNonPreflightRequest");
var isAPIGatewayProxyEvent_1 = require("./type-guards/isAPIGatewayProxyEvent");
var cors = function (options) {
    if (options === void 0) { options = {}; }
    if (!(0, CorsMiddlewareOptions_1.isCorsMiddlewareOptions)(options)) {
        throw new TypeError("Received invalid options object ".concat(JSON.stringify(options, null, 2)));
    }
    var fullOptions = (0, tslib_1.__assign)({ allowedHeaders: null, cacheControl: null, allowCredentials: false, exposedHeaders: [], maxAge: null, allowedMethods: ["GET", "HEAD", "PUT", "PATCH", "POST", "DELETE"], optionsSuccessStatus: 204, allowedOrigins: [], preflightContinue: false }, options);
    return function (handler) { return function (event, context) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
        var runHandler;
        return (0, tslib_1.__generator)(this, function (_a) {
            runHandler = function () { return handler(event, context); };
            if ((0, isAPIGatewayProxyEvent_1.isAPIGatewayProxyEvent)(event)) {
                if (event.httpMethod.toLowerCase() === "options") {
                    return [2 /*return*/, (0, handlePreflightRequest_1.handlePreflightRequest)(runHandler, event, fullOptions)];
                }
                return [2 /*return*/, (0, handleNonPreflightRequest_1.handleNonPreflightRequest)(runHandler, event, fullOptions)];
            }
            if (event.requestContext.http.method.toLowerCase() === "options") {
                return [2 /*return*/, (0, handlePreflightRequest_1.handlePreflightRequest)(runHandler, event, fullOptions)];
            }
            return [2 /*return*/, (0, handleNonPreflightRequest_1.handleNonPreflightRequest)(runHandler, event, fullOptions)];
        });
    }); }; };
};
exports.cors = cors;
//# sourceMappingURL=cors.js.map