"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleNonPreflightRequest = void 0;
var tslib_1 = require("tslib");
var logger_1 = require("./logger");
var createAllowOriginHeader_1 = require("./headers/createAllowOriginHeader");
var createAllowCredentialsHeader_1 = require("./headers/createAllowCredentialsHeader");
var createExposeHeadersHeader_1 = require("./headers/createExposeHeadersHeader");
var mergeHeaders_1 = require("./mergeHeaders");
function handleNonPreflightRequest(handler, event, options) {
    var _a;
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var response;
        return (0, tslib_1.__generator)(this, function (_b) {
            switch (_b.label) {
                case 0:
                    (0, logger_1.logger)("Handle non-preflight request");
                    (0, logger_1.logger)("Running handler");
                    return [4 /*yield*/, handler()];
                case 1:
                    response = _b.sent();
                    (0, logger_1.logger)("Returning response");
                    return [2 /*return*/, (0, tslib_1.__assign)((0, tslib_1.__assign)({}, response), { headers: (0, mergeHeaders_1.mergeHeaders)((0, createAllowOriginHeader_1.createAllowOriginHeader)(event.headers, options.allowedOrigins), (0, createAllowCredentialsHeader_1.createAllowCredentialsHeader)(options.allowCredentials), (0, createExposeHeadersHeader_1.createExposeHeadersHeader)(options.exposedHeaders), (_a = response.headers) !== null && _a !== void 0 ? _a : {}) })];
            }
        });
    });
}
exports.handleNonPreflightRequest = handleNonPreflightRequest;
//# sourceMappingURL=handleNonPreflightRequest.js.map