"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handlePreflightRequest = void 0;
var tslib_1 = require("tslib");
var createAllowCredentialsHeader_1 = require("./headers/createAllowCredentialsHeader");
var createAllowHeadersHeader_1 = require("./headers/createAllowHeadersHeader");
var createAllowMethodsHeader_1 = require("./headers/createAllowMethodsHeader");
var createAllowOriginHeader_1 = require("./headers/createAllowOriginHeader");
var createCacheControlHeader_1 = require("./headers/createCacheControlHeader");
var createExposeHeadersHeader_1 = require("./headers/createExposeHeadersHeader");
var logger_1 = require("./logger");
var mergeHeaders_1 = require("./mergeHeaders");
function handlePreflightRequest(handler, event, options) {
    var _a;
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var response, _b;
        return (0, tslib_1.__generator)(this, function (_c) {
            switch (_c.label) {
                case 0:
                    (0, logger_1.logger)("Handle pre-flight request");
                    if (!options.preflightContinue) return [3 /*break*/, 2];
                    return [4 /*yield*/, handler()];
                case 1:
                    _b = _c.sent();
                    return [3 /*break*/, 3];
                case 2:
                    _b = {
                        body: "",
                        headers: {
                            "Content-Length": "0",
                        },
                        statusCode: options.optionsSuccessStatus,
                    };
                    _c.label = 3;
                case 3:
                    response = _b;
                    return [2 /*return*/, (0, tslib_1.__assign)((0, tslib_1.__assign)({}, response), { headers: (0, mergeHeaders_1.mergeHeaders)((0, createAllowMethodsHeader_1.createAllowMethodsHeader)(options.allowedMethods), (0, createAllowHeadersHeader_1.createAllowHeadersHeader)(event.headers, options.allowedHeaders), (0, createCacheControlHeader_1.createCacheControlHeader)(options.cacheControl), (0, createAllowCredentialsHeader_1.createAllowCredentialsHeader)(options.allowCredentials), (0, createExposeHeadersHeader_1.createExposeHeadersHeader)(options.exposedHeaders), (0, createAllowOriginHeader_1.createAllowOriginHeader)(event.headers, options.allowedOrigins), (_a = response.headers) !== null && _a !== void 0 ? _a : {}) })];
            }
        });
    });
}
exports.handlePreflightRequest = handlePreflightRequest;
//# sourceMappingURL=handlePreflightRequest.js.map