"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAllowHeadersHeader = void 0;
var logger_1 = require("../logger");
function createAllowHeadersHeader(headers, allowedHeaders) {
    var _a;
    (0, logger_1.logger)("Checking if allowedHeaders is set");
    if (allowedHeaders) {
        (0, logger_1.logger)("allowedHeaders is set, setting header to it");
        return {
            "Access-Control-Allow-Headers": allowedHeaders.join(","),
        };
    }
    var value = (_a = headers["Access-Control-Request-Headers"]) !== null && _a !== void 0 ? _a : headers["access-control-request-headers"];
    (0, logger_1.logger)("allowedHeaders is not set, reading incoming header and setting header to ".concat(value));
    return {
        "Access-Control-Allow-Headers": value,
        Vary: "Access-Control-Request-Headers",
    };
}
exports.createAllowHeadersHeader = createAllowHeadersHeader;
//# sourceMappingURL=createAllowHeadersHeader.js.map