"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createExposeHeadersHeader = void 0;
var logger_1 = require("../logger");
function createExposeHeadersHeader(exposedHeaders) {
    (0, logger_1.logger)("Checking whether to set exposed headers header");
    if (exposedHeaders.length === 0) {
        (0, logger_1.logger)("No exposed headers, not setting header");
        return {};
    }
    (0, logger_1.logger)("Setting Access-Control-Expose-Headers header");
    return { "Access-Control-Expose-Headers": exposedHeaders.join(",") };
}
exports.createExposeHeadersHeader = createExposeHeadersHeader;
//# sourceMappingURL=createExposeHeadersHeader.js.map